class NoAccountsError(Exception):
	'Raise when doing an action that requires a fediverse account, but none exist'

class AccountNotFoundError(Exception):
	'Raise when a specific account is not found'

class BitwardenApiError(Exception):
	'Raise when a Bitwarden command fails'

class NoPasswordError(Exception):
	'Raise when there is not result when fetching a single password row'

	def __init__(self, item_id):
		Exception.__init__(self, f'No row for password with ID: {item_id}')
		self.item_id = item_id
