import ftplib, mimetypes, traceback

from izzylib import class_name

from . import ProtocolRequest, handle_remote_file, list_directory

from ..functions import get_app, human_bytes


## This is probably gonna get removed if I can't eventually get a protocol handler setup
def Ftp(webview_request):
	request = ProtocolRequest(webview_request)
	filelist = []

	with ftplib.FTP(request.domain, timeout=10) as ftp:
		#ftp.set_debuglevel(2)

		if request.url.username:
			with get_app().db.session as s:
				if request.url.password:
					ftp.login(request.url.username, request.url.password)

				elif (creds := s.fetch('ftpcreds', domain=request.domain, username=request.url.username).one()):
					ftp.login(creds.username, creds.password)

		try:
			for filename, data in ftp.mlsd(request.path, facts=['size', 'type']):
				data['mimetype'] = mimetypes.guess_type(filename)[0]

				if filename.startswith('.'):
					continue

				filelist.append(DotDict(
					filename = filename,
					shortname = filename[:30] + '...' if len(filename) > 30 else filename,
					size = human_bytes(data['size']),
					mimetype = data['mimetype'],
					type = data['type'],
					user = '',
					group = ''
				))

			return list_directory(request, filelist)

		except ftplib.error_perm as e:
			if not str(e).startswith('501'):
				traceback.print_exc()
				return request.error(f'{class_name(e)}: {e}', 'Something Fucked Up')

			return request.error('Downloading files not supported yet')

		except Exception as e:
			traceback.print_exc()
			return request.error(f'{class_name(e)}: {e}', 'Something Fucked Up')
