import random

from mastodon import Mastodon

from . import ProtocolHandler

from .. import __software__, var


new_apps = DotDict()

blocked_instances = {
	'baraag.net',
	'freespeechextremist.com',
	'gameliberty.club',
	'gleasonator.com',
	'glindr.org',
	'kiwifarms.cc',
	'ligma.pro',
	'mentality.rip',
	'neckbeard.xyz',
	'nobodyhasthe.biz',
	'pawoo.net',
	'shitposter.club',
	'welovela.in',
	'yggdrasil.social'
}

blocked_instance_responses = [
	'https://www.youtube.com/watch?v=NErXHDMDX6Q', #That's it! I'm gettin' me mallet!
	'https://www.youtube.com/watch?v=RwC9CP_2YKE' #JREG - Why You Should Go Fuck Yourself: A Presentation
]


Oauth = ProtocolHandler('oauth')


@Oauth.route('/login')
def oauth_login(handler, request):
	domain = request.query.get('domain')

	if Url.new(domain).top in blocked_instances:
		with db.session as s:
			s.put_permission('www.youtube.com', 'autoplay', True)
			s.put_permission('youtube.com', 'autoplay', True)

		return request.redirect(random.choice(blocked_instance_responses))

	if not domain:
		return request.redirect(
			var.local + '/fediverse',
			'Domain not provided for oauth login',
			'error'
		)

	appid = random_str()
	app = get_app_data(appid)

	try:
		if not (app_data := Mastodon.create_app(api_base_url=f'https://{domain}', **app)):
			return request.error('Failed to create app', 500)

	except ConnectionError:
		return request.error(f'Failed to contact instance: {domain}', 500)

	app.update({
		'id': appid,
		'domain': domain,
		'client_id': app_data[0],
		'client_secret': app_data[1]
	})

	new_apps[appid] = app

	query = {
		'response_type': 'code',
		'client_id': app.client_id,
		'redirect_uri': app.redirect_uris,
		'scope': ' '.join(app.scopes)
	}

	# todo: use Mastodon.auth_request_url
	url = Url.new(domain=domain, path='/oauth/authorize', query=query)

	return request.redirect(url)


@Oauth.route('/create/{appid}')
def oauth_create(handler, request, appid):
	if not (app := new_apps.pop(appid, None)):
		return request.redirect(var.local + '/fediverse', f'App with appid does not exist: {appid}', 'error')

	if not (code := request.query.get('code')):
		return request.redirect(var.local + '/fediverse', 'Authorization code not passed to oauth', 'error')

	masto = Mastodon(api_base_url=f'https://{app.domain}', client_id=app.client_id, client_secret=app.client_secret)

	if not (token := masto.log_in(code=code, redirect_uri=app.redirect_uris, scopes=app.scopes)):
		return request.redirect(var.local + '/fediverse', 'Failed to get app token', 'error')

	if not (user_data := masto.account_verify_credentials()):
		return request.redirect('Failed to get user data', 'error')

	user_data = DotDict(user_data)

	try:
		instance = DotDict(masto.instance())

	except:
		instance = {}

	with request.db.session as s:
		s.put_account(app.domain, token, user_data, instance.get('max_toot_chars', 500))
		s.commit()

		try:
			row = s.get_account(user_data.username, app.domain)

		except KeyError:
			return request.error('Failed to add account to database')

	request.app.accounts.append(row)
	row.fetch_avatar()
	return request.redirect(var.local + '/fediverse', f'Successfully signed into {user_data.username}@{app.domain}')


def get_app_data(appid):
	return DotDict({
		'client_name': __software__,
		'redirect_uris': 'https://pyweb-oauth/create/' + appid,
		'scopes': ['read', 'write', 'follow'],
		'website': 'https://git.barkshark.xyz/izaliamae/barkshark-web'
	})
